



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mysql的表和数据类型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mysql的表和数据类型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 23:22:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、查看当前数据库所有表</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; use db<br />
Database changed<br />
mysql&gt; show tables;<br />
Empty set (0.00 sec)  #表示db数据库下无数据表。
</pre>
</div>
<p><strong>二、建立表</strong></p>
<div>
<pre class="prettyprint linenums">create table customers(id int unsigned not null auto_increment,<br />
name varchar(30) not null,<br />
primary key(id))<br />
engine=myisam character set=utf8;
</pre>
</div>
<p><strong>三、查看当前数据库表的结构</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; desc customers;<br />
+-------+------------------+------+-----+---------+----------------+<br />
| Field | Type             | Null | Key | Default | Extra          |<br />
+-------+------------------+------+-----+---------+----------------+<br />
| id    | int(10) unsigned | NO   | PRI | NULL    | auto_increment |<br />
| name  | varchar(30)      | NO   |     | NULL    |                |<br />
+-------+------------------+------+-----+---------+----------------+<br />
2 rows in set (0.00 sec)
</pre>
</div>
<p><strong>四、数据类型</strong></p>
<p><strong>1、整型</strong></p>
<table>
<tbody>
<tr>
<td><strong>MySQL数据类型</strong></td>
<td><strong>含义（有符号）</strong></td>
</tr>
<tr>
<td>tinyint(m)</td>
<td>1个字节&nbsp; 范围(-128~127)</td>
</tr>
<tr>
<td>smallint(m)</td>
<td>2个字节&nbsp; 范围(-32768~32767)</td>
</tr>
<tr>
<td>mediumint(m)</td>
<td>3个字节&nbsp; 范围(-8388608~8388607)</td>
</tr>
<tr>
<td>int(m)</td>
<td>4个字节&nbsp; 范围(-2147483648~2147483647)</td>
</tr>
<tr>
<td>bigint(m)</td>
<td>8个字节&nbsp; 范围(+-9.22*10的18次方)</td>
</tr>
</tbody>
</table>
<p>取值范围如果加了unsigned，则最大值翻倍，如tinyint unsigned的取值范围为(0~256)。&nbsp;<br />int(m)里的m是表示SELECT查询结果集中的显示宽度，并不影响实际的取值范围，没有影响到显示的宽度。如果不足指定的宽度就在前面用0填充，但必须加上zerofill关键字。</p>
<p><strong>2、浮点型(float和double)</strong></p>
<table>
<tbody>
<tr>
<td><strong>MySQL数据类型</strong></td>
<td><strong>含义</strong></td>
</tr>
<tr>
<td>float(m,d)</td>
<td>单精度浮点型&nbsp;&nbsp;&nbsp; 8位精度(4字节)&nbsp;&nbsp;&nbsp; &nbsp;m总个数，d小数位</td>
</tr>
<tr>
<td>double(m,d)</td>
<td>双精度浮点型&nbsp;&nbsp;&nbsp; 16位精度(8字节)&nbsp;&nbsp; &nbsp;m总个数，d小数位</td>
</tr>
</tbody>
</table>
<p>设一个字段定义为float(5,3)，如果插入一个数123.45678,实际数据库里存的是123.457，但总个数还以实际为准，即6位。</p>
<p><strong>3、定点数</strong></p>
<p>decimal和numeric一样。</p>
<p>浮点型在数据库中存放的是近似值，而定点类型在数据库中存放的是精确值。&nbsp;<br />decimal(m,d) 参数m&lt;65 是总个数，d&lt;30且 d&lt;m 是小数位。</p>
<p><strong>4、字符串(char,varchar,_text)</strong></p>
<table>
<tbody>
<tr>
<td><strong>MySQL数据类型</strong></td>
<td><strong>含义</strong></td>
</tr>
<tr>
<td>char(n)</td>
<td>固定长度，最多255个字符</td>
</tr>
<tr>
<td>varchar(n)</td>
<td>固定长度，最多65535个字符</td>
</tr>
<tr>
<td>tinytext</td>
<td>可变长度，最多255个字符</td>
</tr>
<tr>
<td>text</td>
<td>可变长度，最多65535个字符</td>
</tr>
<tr>
<td>mediumtext</td>
<td>可变长度，最多2的24次方-1个字符</td>
</tr>
<tr>
<td>longtext</td>
<td>可变长度，最多2的32次方-1个字符</td>
</tr>
</tbody>
</table>
<p>char和varchar：<br />1.char(n) 若存入字符数小于n，则以空格补于其后，查询之时再将空格去掉。所以char类型存储的字符串末尾不能有空格，varchar不限于此。&nbsp;<br />2.char(n) 固定长度，char(4)不管是存入几个字符，都将占用4个字节，varchar是存入的实际字符数+1个字节（n&lt;=255）或2个字节(n&gt;255)，所以varchar(4),存入3个字符将占用4个字节。&nbsp;<br />3.char类型的字符串检索速度要比varchar类型的快。</p>
<p>varchar和text：&nbsp;<br />1.varchar可指定n，text不能指定，内部存储varchar是存入的实际字符数+1个字节（n&lt;=255）或2个字节(n&gt;255)，text是实际字符数+2个字节。&nbsp;<br />2.text类型不能有默认值。&nbsp;<br />3.varchar可直接创建索引，text创建索引要指定前多少个字符。varchar查询速度快于text,在都创建索引的情况下，text的索引似乎不起作用。</p>
<p><strong>5.二进制数据(_Blob)</strong></p>
<p>1._BLOB和_text存储方式不同，_TEXT以文本方式存储，英文存储区分大小写，而_Blob是以二进制方式存储，不分大小写。&nbsp;<br />2._BLOB存储的数据只能整体读出。&nbsp;<br />3._TEXT可以指定字符集，_BLO不用指定字符集。</p>
<p><strong>6.日期时间类型</strong></p>
<table>
<tbody>
<tr>
<td><strong>MySQL数据类型</strong></td>
<td><strong>含义</strong></td>
</tr>
<tr>
<td>date</td>
<td>日期 '2008-12-2'</td>
</tr>
<tr>
<td>time</td>
<td>时间 '12:25:36'</td>
</tr>
<tr>
<td>datetime</td>
<td>日期时间 '2008-12-2 22:06:44'</td>
</tr>
<tr>
<td>timestamp</td>
<td>自动存储记录修改时间</td>
</tr>
</tbody>
</table>
<p>若定义一个字段为timestamp，这个字段里的时间数据会随其他字段修改的时候自动刷新，所以这个数据类型的字段可以存放这条记录最后被修改的时间。</p>
<p><strong>数据类型的属性</strong></p>
<table>
<tbody>
<tr>
<td><strong>MySQL关键字</strong></td>
<td><strong>含义</strong></td>
</tr>
<tr>
<td>NULL</td>
<td>数据列可包含NULL值</td>
</tr>
<tr>
<td>NOT NULL</td>
<td>数据列不允许包含NULL值</td>
</tr>
<tr>
<td>DEFAULT</td>
<td>默认值</td>
</tr>
<tr>
<td>PRIMARY KEY</td>
<td>主键</td>
</tr>
<tr>
<td>AUTO_INCREMENT</td>
<td>自动递增，适用于整数类型</td>
</tr>
<tr>
<td>UNSIGNED</td>
<td>无符号</td>
</tr>
<tr>
<td>CHARACTER SET name</td>
<td>指定一个字符集</td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwe0pkq.html">Visual Studio 各种版本的快捷键总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m013r9.html">MyBatis知多少（18）MyBatis系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wx5zlq.html">7 linux服务器程序规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vlmro8.html">HDU4527&plus;BFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mwk7eq.html">通过 Azure Media Encoder 降低编码成本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn744pq.html">详谈typedef的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okzkj59.html">Java坑一</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okxmkl9.html">【转】20个令人敬畏的jQuery插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5y0m8.html">java设计模式之八代理模式（Proxy）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojdjdpq.html">运行CImg库笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdww7679.html">在Azure虚拟机上部署FileZilla FTP服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko0jkjq.html">CSS鼠标经过另类做法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjl1508.html">cocos2dx 在windows下开启console</a>
		</li>
						<li><a href="https://www.batexi.com/a/902evgjq.html">Leetcode 96</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlnn139.html">深入理解net core中的依赖注入、Singleton、Scoped、Transient（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kze63q.html">TortoiseGit学习系列之TortoiseGit基本操作将提交到本地的项目推送到在线仓库（图文详解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96m7wvv8.html">Maven：程序包org&period;apache&period;log4j不存在问题处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0xm2eq.html">剑指offer-二叉树的镜像18</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77j77jq.html">目标检测之Faster-RCNN的pytorch代码详解&lpar;模型准备篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8knnrk38.html">哨兵和docker容器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qx26wgz8.html">Dubbo2&period;7源码分析-Dubbo是如何整合spring-framework的</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1wmwx9.html">C&num;byte类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p7yw5q.html">&lbrack;转&rsqb;&period;Net实现本地化简易教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9024vxjq.html">Ionic3 UI组件之 ImageViewer</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv6y1gq.html">Mysql开启远程服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vyr72q.html">iOS--支付宝环境集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/953z3km8.html">mybatis之使用注解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e2e5x9.html">彻底弄懂HTTP缓存机制及原理（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em35mk9.html">【学习笔记】--- 老男孩学Python，day18 面向对象------继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjyldo8.html">Implementation：Binary Indexed Tree 树状数组</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
